#include <stdio.h>
#define n1  2048
#define n2  2048
#define n  n1*n2
FILE  *fp,*fp1,*fp2;		
char  head[72][80];
short ccd[n];
float a[n],bias[n],flat[n];

main(int ac,char **av)
{
  char t[80]; 
  if(ac<2){
  printf("\n\t\t ******** 2key *********\n");
  printf("\n\t (raw_light_data - bias)/flat ---> p*.fit\n");
  printf("\n\t Usage:  lc2key !             jiang  20140103,0125\n\n");
  printf(" 1. automatic processing pipeline1 job, not answer any question.\n"); 
  printf(" 2. create a new directory, empty.\n");
  printf(" 3. copy raw_light_files (with bias,flat)  to this directory\n");
  printf(" 4. in this directory, type command: lc2key !\n");
  printf(" 5. p*.fit is the result  (invert Y)\n\n");
  exit(0);
  }
  sprintf(t,"bias.fit");
  fp=fopen(t,"rb"); if(!fp){
    sprintf(t,"../bias/bias.fit");
    fp=fopen(t,"rb");
    if(!fp){printf("\n\tbias.fit not found! (also in ../bias)\n"); exit(0); }
  }
  fread(head,72,80,fp); fread(bias,n,4,fp); fclose(fp); swap4(bias,n*4);
  sprintf(t,"flat.fit");
  fp=fopen(t,"rb"); if(!fp){ printf("\n\t%s not found!\n",t); exit(0); }
  fread(head,72,80,fp); fread(flat,n,4,fp); fclose(fp); swap4(flat,n*4);
  work(a);
} 

work(float *a)
{
  int i,j,k,ip; char t[60],b[60],c; float x,s;
  sprintf(t,"ls *.fit >1.1"); system(t);
  fp=fopen("1.1","r"); ip=0;
l10:
  fgets(t,60,fp); if(feof(fp))goto l20;           // assume  ...B_12345.fit
  t[strlen(t)-1]=0; 
  fp1=fopen(t,"rb"); fread(head,72,80,fp1);
  k=indexpos(head,"BITPIX  ",72);
  sscanf(&head[k][20],"%d",&j);   if(j!=16)goto l30;
  k=indexpos(head,"NAXIS1  ",72);
  sscanf(&head[k][20],"%d",&j);   if(j!=n1)goto l30;
  sscanf(&head[k+1][20],"%d",&j); if(j!=n2)goto l30;
  k=indexpos(head,"CCDTYPE ",72); if(head[k][11]!='L')goto l30;
  fread(ccd,n,2,fp1); swap2(ccd,n*2); 
  for(j=0;j<n;j++){ x=ccd[j]+32768; x-=bias[j]; x/=flat[j];
     if(x<=0.)x=0.1;                             // 2014,1,18
     a[j]=x; }
  for(j=k=0;j<n;j++)if(a[j]>0. && a[j]<32768.)ccd[k++]=a[j];
  white_black(ccd,1,k,&x,&s);
  k=indexpos(head,"RA      ",72);
  for(j= 5;j<=6;j++){ for(i=0;i<80;i++)head[j][i]=head[k][i]; k++; }
  k-=2;
  head[k][3]=head[k+1][3]='-';
  head[k][4]=head[k+1][4]='O';
  head[k][5]=head[k+1][5]='B';
  head[k][6]=head[k+1][6]='S';
  k=indexpos(head,"END     ",72);
  head[k][0]=head[k][1]=head[k][2]=32;
  head[71][0]='E'; head[71][1]='N'; head[71][2]='D'; 
  strncpy(&head[1][27],"-32",3);	/* real*4 */
  k=indexpos(head,"DATE-OBS",72);
  sprintf(head[k+2],"TIME-OBS= '");for(i=11;i<24;i++)head[k+2][i]=head[k][11+i];
                                   for(i=24;i<31;i++)head[k+2][i]=32;
  for(i=22;i<36;i++)head[k][i]=32; head[k][21]=head[k][10];
  for(i=0;i<31;i++){ c=head[k+1][i]; head[k+1][i]=head[k+2][i]; head[k+2][i]=c;}
  for(j=32;j<44;j++)for(i=0;i<31;i++)head[j+25][i]=head[j][i];
  sprintf(head[32],"SKYADU  = %20.2f ",x);
  for(i=0;i<69;i++)head[i][31]='/';
  sprintf(b,"p%s",t);
  printf("%5d: %s %9.2f --> %s\n",++ip,t,x,b);
  fp2=fopen(b,"wb");       // invert_Y
  fwrite(head,72,80,fp2); swap4(a,n*4);
  for(j=n2-1;j>=0;j--) fwrite(&a[j*n1],4,n1,fp2);
  fclose(fp2);  
l30:
  fclose(fp1);
  goto l10;
l20:
  fclose(fp);
}
